VERSION 5.00
Begin VB.Form FormKey 
   Caption         =   "Key Generator"
   ClientHeight    =   705
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4080
   LinkTopic       =   "Form1"
   ScaleHeight     =   705
   ScaleWidth      =   4080
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Visible         =   0   'False
End
Attribute VB_Name = "FormKey"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' element 5 / ShareIt! key generator example
' version 2.5
Option Explicit

' predefined exit codes - DO NOT CHANGE
Const ERC_SUCCESS = 0
Const ERC_SUCCESS_BIN = 1
Const ERC_ERROR = 10
Const ERC_MEMORY = 11
Const ERC_FILE_IO = 12
Const ERC_BAD_ARGS = 13
Const ERC_BAD_INPUT = 14
Const ERC_EXPIRED = 15
Const ERC_INTERNAL = 16

' possible values for language_id
Const liEnglish = 1
Const liGerman = 2
Const liPortuguese = 3
Const liSpanish = 4
Const liItalian = 5
Const liFrench = 6

' required for the passing of exit codes
Private Declare Sub ExitProcess Lib "kernel32" (ByVal uExitCode As Long)
Private ExitCode As Long
Private ErrDesc As String

' variables filled by Sub Parse
Dim regname As String, email As String
Dim language

' variables for the generated keys
Dim key1 As String, key2 As String

' array of strings used for command line arguments
Dim ArgArray(3) As String

' Get command line arguments. (taken from the vb help)
Function GetCommandLine()
    Dim CmdLine As String
    Dim c, CmdLnLen, i, NumArgs As Integer
    Dim InArg As Boolean
    
    NumArgs = 0
    InArg = False
    CmdLine = Command()
    CmdLnLen = Len(CmdLine)
    
    'Go thru command line one character at a time.
    For i = 1 To CmdLnLen
        c = Mid(CmdLine, i, 1)
        'Test for space or tab.
        If (c <> " ") Then
            'Neither space nor tab. Test if already in argument.
            If Not InArg Then
            'New argument begins. Test for too many arguments.
                If NumArgs = 3 Then Exit For
                NumArgs = NumArgs + 1
                InArg = True
            End If
            'Concatenate character to current argument.
            ArgArray(NumArgs) = ArgArray(NumArgs) & c
        Else
            'Found a space or tab.
            InArg = False
        End If
    Next i
    
    'Return Array in Function name.
    GetCommandLine = ArgArray()
End Function

' parse a single input file line
Private Sub Parse(line As String)
    Dim c As Integer
    Dim key, value As String
        
    ' split line into key and value
    c = InStr(1, line, "=")
    If c = 0 Then Exit Sub
    
    key = UCase(Left(line, c - 1))
    value = Right(line, Len(line) - c)
    
    ' assign key values to variables
    If key = "REG_NAME" Then regname = value
    If key = "EMAIL" Then email = value
    If key = "LANGUAGE_ID" Then language = value
    '
    ' add more lines as you need them
    '
End Sub

' read an input file with error handling
Private Sub LoadInput()
    On Error GoTo DoErr
    Dim line As String
 
    Open ArgArray(1) For Input As #1
    While Not EOF(1)
        Line Input #1, line
        Parse line
    Wend
    Close #1
    
    Exit Sub

DoErr:
    ExitCode = ERC_FILE_IO
    ErrDesc = Err.Description & " " & ArgArray(1)
End Sub

' write an output file with error handling
Private Sub WriteOutput(name As String, text As String)
    On Error GoTo DoErr
    
    Open name For Output As #1
    Print #1, text
    Close #1
    
    Exit Sub
 
DoErr:
    ExitCode = ERC_FILE_IO
    ErrDesc = Err.Description
End Sub

' implement you key generator here
Private Sub GenKey()
    ' check for valid input
    If Len(regname) < 8 Then
        ErrDesc = "<REG_NAME> must have at least 8 characters!"
        ExitCode = ERC_BAD_INPUT
        Exit Sub
    End If

    ' dummy key generation
    key2 = "87x-231-as8-654"
    
    If language = liGerman Then
       key1 = "Benutzername: " & regname & vbCr & vbLf & "Passwort: " & key2
    Else
       key1 = "Username: " & regname & vbCr & vbLf & "Password: " & key2
    End If
   
    ExitCode = ERC_SUCCESS
End Sub

' main entry point
Private Sub Form_Load()
    On Error GoTo DoErr
    ExitCode = ERC_SUCCESS
    
    ' get command line arguments
    GetCommandLine
    If ExitCode <> ERC_SUCCESS Then GoTo DoErr:
 
    ' read input file
    LoadInput
    If ExitCode <> ERC_SUCCESS Then GoTo DoErr:
 
    ' call key generator
    GenKey
    If ExitCode <> ERC_SUCCESS Then GoTo DoErr:
  
    ' write 1st output file
    WriteOutput ArgArray(2), key1
    If ExitCode <> ERC_SUCCESS Then GoTo DoErr:

    ' write 2nd output file
    WriteOutput ArgArray(3), key2
  
DoErr:
    If (ExitCode <> ERC_SUCCESS) And (ArgArray(2) <> "") Then
      ' try to write error description file
      ' does not use WriteOutput because this would
      ' change the error code if it fails
      On Error GoTo Quit:
      Open ArgArray(2) For Output As #1
      Print #1, ErrDesc
      Close #1
    End If

Quit:
    ' unload the form so that form_terminate gets called
    ' Attention: This will unload your VB IDE as well!
    Unload Me
End Sub

' Call ExitProcess as the last action before closing
' otherwise it prevents proper clean up
' Attention: ExitProcess will also quit the VB IDE!
Private Sub Form_Terminate()
    ExitProcess ExitCode
End Sub

